//---------------------------------------------------------------------------

#ifndef StatPlusUnitH
#define StatPlusUnitH
//----------------------------------------------------------------------------//
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
#include <Clipbrd.hpp>
#include <Registry.hpp>
#include <Dialogs.hpp>
#include "LMDBaseControl.hpp"
#include "LMDBaseGraphicControl.hpp"
#include "LMDBaseMeter.hpp"
#include "LMDControl.hpp"
#include "LMDCustomProgress.hpp"
#include "LMDGraphicControl.hpp"
#include "LMDProgress.hpp"
#include "LMDCustomComponent.hpp"
#include "LMDOneInstance.hpp"             // TRegIniFile


//for Transparent (NT2000, XP only)
typedef BOOL (__stdcall * PFNSetLayeredWindowAttributes)(HWND, COLORREF, BYTE , DWORD );


#ifndef LWA_ALPHA
#define LWA_ALPHA 0x02L
#endif

#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED 0x00080000L
#endif
//END for Transparent


// From TrayIcon Example (BCB5)
#define MYWM_NOTIFY         (WM_APP+100)
#define MYWM_NOTIFY_SHOW    (WM_APP+200)
#define IDC_MYICON          1006
extern HINSTANCE g_hinst;
LRESULT IconDrawItem(LPDRAWITEMSTRUCT lpdi);
//----------------------------------------------------------------------------//
class TFormStatPlus : public TForm
{
__published:	// IDE-managed Components
  TTimer *TimerGUIUpdate;
  TPopupMenu *PopupMenu;
  TMenuItem *mnuEXIT;
  TMenuItem *mnuSep2;
  TColorDialog *ColorDialog;
  TMenuItem *mnuSep3;
  TMenuItem *mnuShow;
  TMenuItem *mnuTaskMsg;
  TMenuItem *mnuBatMsg;
  TMenuItem *mnuSep1;
  TMenuItem *mnuSetting;
  TMenuItem *mnuFont;
  TMenuItem *mnuReloadSetting;
  TMenuItem *mnuSave;
  TMenuItem *mnuAutoRun;
  TPanel *Panel1;
  TLMDProgress *CPUStatus;
  TLMDProgress *MEMStatus;
  TLMDProgress *SWPStatus;
  TLMDProgress *BATStatus;
  TMenuItem *mnuOnTop;
  TMenuItem *mnuShowKeys;
  TMenuItem *mnuScreenSave;
  TMenuItem *mnuFade;
  TMenuItem *mnuMemFree;
  TMenuItem *mnuAutoFree;
  TMenuItem *mnuSep11;
  TMenuItem *mnuAuto1Min;
  TMenuItem *mnuAuto5Min;
  TMenuItem *mnuAuto10Min;
  TMenuItem *mnuSep111;
  TMenuItem *mnuAuto32MB;
  TMenuItem *mnuAuto64MB;
  TMenuItem *mnuAuto128MB;
  TMenuItem *mnuAuto16MB;
  TMenuItem *mnuFree64MB;
  TMenuItem *mnuFree128MB;
  TMenuItem *mnuFree256MB;
  TMenuItem *mnuHide;
  TMenuItem *mnuSep12;
  TMenuItem *mnuAbort;
  TMenuItem *mnuSep112;
  TMenuItem *mnuAutoMore4MB;
  TMenuItem *mnuAutoMore8MB;
  TMenuItem *mnuAutoMore16MB;
  TMenuItem *mnuAutoTrigger;
  TMenuItem *mnuSep110;
  TMenuItem *mnuSep13;
  TMenuItem *mnuMore16MB;
  TMenuItem *mnuMore32MB;
  TMenuItem *mnuMore64MB;
  TFontDialog *FontDialog;
  TMenuItem *mnuTray;
  TMenuItem *mnuTrayCPU;
  TMenuItem *mnuTrayMEM;
  TMenuItem *mnuTrayBAT;
  TMenuItem *mnuColor;
  TMenuItem *mnuSep14;
  TMenuItem *mnuSep15;
  TMenuItem *mnuBatteryInfo;
  TMenuItem *mnuSwapInfo;
  TMenuItem *mnuMemInfo;
  void __fastcall TimerGUIUpdateTimer(TObject *Sender);
  void __fastcall CBoxUnitChange(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall mnuEXITClick(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall BtnFontClick(TObject *Sender);
  void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
  void __fastcall CPUStatusMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall CPUStatusMouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  void __fastcall CPUStatusMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
  void __fastcall mnuTaskMsgClick(TObject *Sender);
  void __fastcall mnuBatMsgClick(TObject *Sender);
  void __fastcall mnuShowClick(TObject *Sender);
  void __fastcall CPUStatusDblClick(TObject *Sender);
  void __fastcall FormHide(TObject *Sender);
  void __fastcall FormCreate(TObject *Sender);
  void __fastcall mnuAutoRunClick(TObject *Sender);
  void __fastcall mnuOnTopClick(TObject *Sender);
  void __fastcall mnuShowKeysClick(TObject *Sender);
  void __fastcall mnuScreenSaveClick(TObject *Sender);
  void __fastcall mnuFadeClick(TObject *Sender);
  void __fastcall mnuHideClick(TObject *Sender);
  void __fastcall mnuAuto1MinClick(TObject *Sender);
  void __fastcall mnuAuto5MinClick(TObject *Sender);
  void __fastcall mnuAuto10MinClick(TObject *Sender);
  void __fastcall mnuAuto16MBClick(TObject *Sender);
  void __fastcall mnuAuto32MBClick(TObject *Sender);
  void __fastcall mnuAuto64MBClick(TObject *Sender);
  void __fastcall mnuAuto128MBClick(TObject *Sender);
  void __fastcall mnuAutoMore4MBClick(TObject *Sender);
  void __fastcall mnuAutoMore8MBClick(TObject *Sender);
  void __fastcall mnuAutoMore16MBClick(TObject *Sender);
  void __fastcall mnuAutoTriggerClick(TObject *Sender);
  void __fastcall mnuFree64MBClick(TObject *Sender);
  void __fastcall mnuFree128MBClick(TObject *Sender);
  void __fastcall mnuFree256MBClick(TObject *Sender);
  void __fastcall mnuMore16MBClick(TObject *Sender);
  void __fastcall mnuMore32MBClick(TObject *Sender);
  void __fastcall mnuMore64MBClick(TObject *Sender);
  void __fastcall mnuSaveClick(TObject *Sender);
  void __fastcall mnuReloadSettingClick(TObject *Sender);
  void __fastcall mnuFontClick(TObject *Sender);
  void __fastcall mnuTrayCPUClick(TObject *Sender);
  void __fastcall mnuTrayMEMClick(TObject *Sender);
  void __fastcall mnuTrayBATClick(TObject *Sender);
  void __fastcall mnuColorClick(TObject *Sender);
  void __fastcall mnuBatteryInfoClick(TObject *Sender);
  void __fastcall mnuSwapInfoClick(TObject *Sender);
  void __fastcall mnuMemInfoClick(TObject *Sender);

private:	// User declarations
  int           iPlatformID;
  bool          bEnableFade;
  TMemoryStatus MemoryStatus;
  int           iUnit;
  bool          bCanClose;
  bool          bFreeingMem;
  bool          bAbort;
  int           iFreeingPercent;
  int           iMaxSize;
  int           iLastInfo;
  AnsiString    MemoryFreeStatusString;
  int           AutoFreeTimeIndex;
  int           AutoFreeMBIndex;
  int           TrayIconIndex;

  TColor        cTrayIconColor;
  TColor        cLargeColor;
  TColor        cSmallColor;
  int           iLargeSize;
  int           iSmallSize;
  AnsiString    FontName;
  int           FontSize[4];
  bool          bAutoFreeMem;
  int           iAutoFreeCount;
  int           iAutoFreeInterval;
  int           iAutoFreeSize;
  bool          bAutoFreeMoreMem;
  AnsiString    IniFileName;
  AnsiString    LangIniFileName;
  bool          bAdditionalMenu;
  bool          bCustomDateTimeString;
  AnsiString    CustomDateTiemString;
  bool          EnableMemInfo;
  bool          EnableSwapInfo;
  bool          EnableBatteryInfo;
  AnsiString    asWeekDay[7];
  AnsiString    asPhyMem;
  AnsiString    asAvlMem;
  AnsiString    asMemFreeing;
  AnsiString    asMemFreeComplete;
  AnsiString    asBatCharging;
  AnsiString    asBatDisCharging;
  AnsiString    asUseACPower;
  AnsiString    asNoBatInfo;

  bool  bMouseDown;
  int   iDownX;
  int   iDownY;
  bool __bStopGetCPUUsage;
  int   iLastCPUusage;
  int   iLastMEM;
  int   iLastSWP;
  int   iLastBAT;
  int   iUpdateTime;
  bool  bShowTotalorAvail;
  int   iShowFadeCount;
  int   iMovingInCount;

  AnsiString    HotKeyWinF[13];
  bool          HotKeyRegistered[13];
  int           HotKeyID[13];
  TStringList  *HotKeyList;
  AnsiString    HotKeyRegisteredString;

  void __fastcall LoadRegIniSetting(void);
  void __fastcall SaveRegIniSetting(void);

  void __fastcall TextToIconBitmap(
    Graphics::TBitmap *pBmpColor, TColor cBGColor, TColor cFGColor,
    Graphics::TBitmap *pBmpMask,  TColor cBGMask,  TColor cFGMask,
    AnsiString asText,AnsiString asFontName,int iFontSize);

  void __fastcall FreeMemory(int iFreeSize);
  void __fastcall UpdateAllStatus(void);

    // From TrayIcon Example (BCB5)
    void __fastcall DrawItem(TMessage& Msg);
    void __fastcall MyNotify(TMessage& Msg);
    void __fastcall MyNotifyShow(TMessage& Msg);
    void __fastcall MyHotKey(TMessage& Msg);
    bool __fastcall TrayMessage(DWORD dwMessage);
    HICON __fastcall IconHandle(void);
    PSTR __fastcall TipText(void);

    int  __fastcall GetCPUUsage(void);
    void __fastcall SetTopMost(void);
    void __fastcall ClearTopMost(void);
    void __fastcall SetTransparent(int Value);
    void __fastcall ClearTransparent(void);

public:		// User declarations
  __fastcall TFormStatPlus(TComponent* Owner);
  __fastcall ~TFormStatPlus();
  int __fastcall GetPlatformID(void);

  HINSTANCE hDllInst;
  typedef bool __stdcall SETLAYER( HWND hwnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags );


// From TrayIcon Example (BCB5)
#pragma option push -w-inl
BEGIN_MESSAGE_MAP
MESSAGE_HANDLER(WM_DRAWITEM,TMessage,DrawItem)
MESSAGE_HANDLER(MYWM_NOTIFY,TMessage,MyNotify)
MESSAGE_HANDLER(MYWM_NOTIFY_SHOW,TMessage,MyNotifyShow)
MESSAGE_HANDLER(WM_HOTKEY,TMessage,MyHotKey)
END_MESSAGE_MAP(TForm)
#pragma option pop


};
//----------------------------------------------------------------------------//
extern PACKAGE TFormStatPlus *FormStatPlus;
//----------------------------------------------------------------------------//
typedef LONG (WINAPI *PROCNTQSI)(UINT,PVOID,ULONG,PULONG);
#define SystemBasicInformation                    0
#define SystemPerformanceInformation    2
#define SystemTimeInformation                       3
#define Li2Double(x) ((double)((x).HighPart) * 4.294967296E9 + (double)((x).LowPart))
typedef struct
{
        DWORD   dwUnknown1;
        ULONG   uKeMaximumIncrement;
        ULONG   uPageSize;
        ULONG   uMmNumberOfPhysicalPages;
        ULONG   uMmLowestPhysicalPage;
        ULONG   uMmHighestPhysicalPage;
        ULONG   uAllocationGranularity;
        PVOID   pLowestUserAddress;
        PVOID   pMmHighestUserAddress;
        ULONG   uKeActiveProcessors;
        BYTE    bKeNumberProcessors;
        BYTE    bUnknown2;
        WORD    wUnknown3;
} SYSTEM_BASIC_INFORMATION;
typedef struct
{
        LARGE_INTEGER   liIdleTime;
        DWORD           dwSpare[76];
} SYSTEM_PERFORMANCE_INFORMATION;
typedef struct
{
        LARGE_INTEGER   liKeBootTime;
        LARGE_INTEGER   liKeSystemTime;
        LARGE_INTEGER   liExpTimeZoneBias;
        ULONG           uCurrentTimeZoneId;
        DWORD           dwReserved;
} SYSTEM_TIME_INFORMATION;

#endif
